#property copyright "Shinigami 2007"
#property link      "teos_ef@mail.ru"

#define ORDER_ID 212598
extern double TakeProfit = 130;
extern double n = 70;
// this was here: extern double Lots = 0.1;
extern string TimeOrders1  = "09:00";
extern string TimeOrders2  = "15:00";
extern string Order_Comment="Shinigami Expert";
extern int UrovenBezubytka =25;
extern int TrailingStop =70; //this is trailing stop

//---- input parameters
extern double    LotsIfNoMM=0.1;
extern bool      UseMM=false;
extern double    MMRiskFactor=0.1;
extern double    MMBalanceExcludeAmt=0;
extern double    MMBalanceShareDivisor=1;



datetime prev_time=0;

void DeleteStopOrders()
{
   int order_type,tf=Period();
   string symb=Symbol();
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==symb&&OrderMagicNumber()==(ORDER_ID+tf))
      {
         order_type=OrderType();
         if(order_type==OP_BUYSTOP||order_type==OP_SELLSTOP)
            OrderDelete(OrderTicket());
      }
   }
}
void Bezubytok()
{
   double dP = UrovenBezubytka*Point;
   //trailer is used for trailing stops
   double trailer = TrailingStop*Point; 
   for(int i=0;i<OrdersTotal();i++)
   {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        
        if(OrderMagicNumber()==(ORDER_ID+Period())&&OrderSymbol()==Symbol())
        {
            if(OrderType()==OP_BUY)
            {
               if(UrovenBezubytka>(Bid-Ask)&&OrderStopLoss()<OrderOpenPrice() && (Bid-OrderOpenPrice())>=dP)
               {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-dP,OrderTakeProfit(),0,Yellow);
               //this part is for trailing stops
               }
               if(TrailingStop>(Bid-Ask) && (Bid-OrderStopLoss())>trailer)
               {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-trailer,OrderTakeProfit(),0,Yellow);
               }
               //end of trailing
                
            }
            if(OrderType()==OP_SELL)
            {                                    
                if(UrovenBezubytka>(Bid-Ask)&&(OrderStopLoss()<Point || OrderStopLoss()>OrderOpenPrice()) && (OrderOpenPrice()-Ask)>=dP )
                {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+dP,OrderTakeProfit(),0,Red);
                //this part is added for trailing stops
                }
                if(TrailingStop>(Bid-Ask)&& (OrderStopLoss()-Ask)>trailer )
                {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+trailer,OrderTakeProfit(),0,Red);
                }
                //end of trailing
            }
        }
   }
   }
   //--- MM calculation
double CalculateMMLot()
  {
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
     {
      Print("CalculateMMLot: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
      return(0);
     }
   if(AccountLeverage()<=0)
     {
      Print("CalculateMMLot: invalid AccountLeverage() [",AccountLeverage(),"]");
      return(0);
     }
//--- basic formula
   lot=NormalizeDouble((AccountBalance()-MMBalanceExcludeAmt)/MMBalanceShareDivisor*MMRiskFactor/AccountLeverage()/10.0,2);
//--- additional calculation
//   ...
//--- check min, max and step
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
//---
   return(lot);
  }
  

int start()
  {
//added lots calculation for MM  
       double Lots;
        if (UseMM) Lots=CalculateMMLot(); else Lots=LotsIfNoMM;
//end of added calculation
  
  
  Bezubytok();
   if(prev_time==Time[0])//   
           return(0);
   prev_time=Time[0];
   int ticket;
   double stoploss=NormalizeDouble(iCustom(NULL,0,"Dolly Graphics(M)",0,0),Digits);
   double sell_stop=NormalizeDouble(iCustom(NULL,0,"Dolly Graphics(M)",1,0),Digits);
   double buy_stop=NormalizeDouble(iCustom(NULL,0,"Dolly Graphics(M)",2,0),Digits);
   if(TimeToStr(CurTime(), TIME_MINUTES)==TimeOrders1||TimeToStr(CurTime(), TIME_MINUTES)==TimeOrders2&&Close[0]<buy_stop&&Close[0]>sell_stop)
   {
       DeleteStopOrders();
       ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,sell_stop,3,stoploss+n*Point,sell_stop-TakeProfit*Point,Order_Comment,ORDER_ID+Period(),0,Red);
       if(ticket<=0)
            Print("Error opening SELLSTOP order : ",GetLastError());
       ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,buy_stop,3,stoploss-n*Point,buy_stop+TakeProfit*Point,Order_Comment,ORDER_ID+Period(),0,Yellow);
       if(ticket<=0)
            Print("Error opening BUYSTOP order : ",GetLastError());
   }
   return(0);
  }